//***********************************************
//
// Reflector_Update.jsx
//
// developed for Zaxwerks Inc.
// by Dan Ebberts
// debberts@comcast.net
//
// copyright 2000 Zaxwerks Inc.
// ALL RIGHTS RESERVED
//***********************************************

{

  //*************
  //
  // main routine
  //
  //*************

  function main(){

    //*****************
    //
    // global constants
    //
    //*****************

    var g = {};

    g.dialogTitle        = " 3D Reflector Updater";
    g.panelText          = "        Click to Update       ";
    g.updateFrameBtnText = "Update This Frame";
    g.updateCompBtnText  = "Update This Comp";
    g.pluginName         = "ZW_RF_Devel";
    g.updateCompParm     = "ZW_RF_Devel-0019";
    g.updateFrameParm    = "ZW_RF_Devel-0020";


    //*******************************
    //
    // function to update reflections
    //
    //*******************************

    function update(theParam){

      var myProject = app.project;
      var myLayer;
      var myEffects;
      var myEffect;
      var myProperty;
      var myComp = myProject.activeItem;
      if ((myComp == null) || ! (myComp instanceof CompItem)){
        alert("Please make sure the Comp or Timeline window is active!");
        return;
      }

      for (var j = 1; j <= myComp.numLayers; j++){
        myLayer = myComp.layer(j);
        myEffects = myLayer.property("ADBE Effect Parade");
        if (myEffects != null){
          for (var k = 1; k <= myEffects.numProperties; k++){
            myEffect = myEffects.property(k);
            if (myEffect.matchName == g.pluginName){
              myProperty = myEffect.property(theParam);
              myProperty.setValue(myProperty.value + 1);
            }
          } 
        }      
      }

      return; // all done
    }

    //***************************************
    //
    // function to handle update frame button
    //
    //***************************************

    function updateFrame(){

      update(g.updateFrameParm);

    }

    //***************************************
    //
    // function to handle update comp button
    //
    //***************************************

    function updateComp(){

      update(g.updateCompParm);

    }

    //**************************
    //
    // function to build palette
    //
    //**************************

    function buildPalette(){

      var palette = new Window("palette",g.dialogTitle, [250, 200, 450, 330]);
      var h = palette.bounds.height;
      var w = palette.bounds.width;

     // update panel

      palette.updatePnl = palette.add("panel",[15,15,palette.bounds.width-15,palette.bounds.height-15],g.panelText);

      // update frame button

      palette.updateFrameBtn = palette.updatePnl.add("button", [20,20,146,42], g.updateFrameBtnText);
      palette.updateFrameBtn.onClick = updateFrame;

      // update comp button

      palette.updateCompBtn = palette.updatePnl.add("button", [20,58,146,80], g.updateCompBtnText);
      palette.updateCompBtn.onClick = updateComp;

      return palette;

    }

    var palette = buildPalette();
    palette.show();

  }

  //*****************
  //
  // call main routine
  //
  //******************

  main();

}

